
declare namespace ResumeType {
    type basic = {
        id ?: Number,
		customer_id ?: Number,
		hide_resume ?: Number,
		house_keeping_status ?: Number,
		photo ?: String,
		name ?: String,
		id_number ?: String,
		gender ?: String,
		dob ?: String,
		work_experience ?: Number,
		education ?: Number,
		reg_level1 ?: Number,
		reg_level2 ?: Number,
		reg_level3 ?: Number,
		reg_level4 ?: Number,
		now_level1 ?: Number,
		now_level2 ?: Number,
		now_level3 ?: Number,
		now_level4 ?: Number,
		title ?: Number,
		marital_status ?: Number,
		ethnicity ?: Number,
		height ?: Number,
		weight ?: Number,
		political_status ?: Number,
		native_place ?: Number,

		// 其他参数
        reg_arr ?: number[] 
		now_arr ?: number[]
        native_arr ?: number[]
    }

    type contact = {
        id ?: Number,
		customer_id ?: Number,
		landline?: String,
		mobile?: String,
		qq?: String,
		personal_website?: String,
		mailing_address?: String,
		postal_code?: String,
    }

    type introduction = {
        id ?: Number,
		customer_id ?: Number,
		description ?: String,
    }

    type skill = {
        id ?: Number,
		customer_id ?: Number,
		english?: Number,
		mandarin?: Number,
		cantonese?: Number,
		other_language?: Number,
		computer_skills?: String,
		vehicle_type?: Number,
		vehicle_type_other?: String,
		drive_type?: String,

    }

	type train = {
		id ?:Number,
		customer_id ?: Number,
		start_year ?: Number,
		start_month ?: Number,
		end_year  ?: Number,
		end_month  ?: Number,
		end_today  ?: Number,
		school_or_institution ?: String,
		major ?: String,
		certificate ?: String,
		awards ?: String,
		positions_held ?: String,
	}

	type experience = {
		id ?:Number,
		customer_id ?: Number,
		start_year ?: Number,
		start_month ?: Number,
		end_year  ?: Number,
		end_month  ?: Number,
		end_today  ?: Number,
		company_name ?: String,
		position ?: String,
		reason_for_leaving ?: String,
	}

	type credential = {
		id ?:Number,
		customer_id ?: Number,
		name ?: String,
		description ?: String,
		certificate_photo ?: String,
	}

	type intentionBasic = {
		id ?: Number,
		customer_id ?: Number,
		job_type?: Number,
		talent_type ?: Number,
		work_experience ?: Number,
		other_positions: '',
		salary_range ?: Number,
		available_date ?: Number,
		title_requirement ?: Number,
		skill_certification ?: Number,
		accommodation_requirement ?: Number,
		holiday_rest ?: Number,
	}

	type intentionArea = {
		id ?: Number,
		customer_id ?: Number,
		level1 ?: Number,
		level2 ?: Number,
		level3 ?: Number,
		level4 ?: Number,

	}

	type intentionIndustry = {
		id ?: Number,
		customer_id ?: Number,
		industry ?: Number
	}

	type intentionPosition = {
		id ?: Number,
		customer_id ?: Number,
		level1 ?: Number,
		level2 ?: Number,
		industry ?: Number
	}

	type account = {
		id ?: Number,
		role?: Number,
		mobile?: String,
		username?: String,
		password?: String,
		email?: String,
	}
}